#ifndef _LDM_EXTRA_H_
#define _LDM_EXTRA_H_

/* Work around <linux/config.h> */

#define CONFIG_LDM_DEBUG 1

#include <linux/version.h>

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,1)
void exit (int status);
#define BUG_ON(condition)							\
	do {									\
		if (condition) {						\
			printk (KERN_CRIT "BUG in %s(%d) %s [%s]\n",		\
				__FILE__, __LINE__, __FUNCTION__, #condition);	\
			exit (1);						\
		}								\
	} while(0)
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,2)
typedef struct list_head list_t;
#endif

#include <linux/slab.h>
#include <linux/pagemap.h>

void * __kmalloc (size_t size, int flags, char *fn);
void   __kfree   (const void *objp, char *fn);

#define kmalloc(X,Y)	__kmalloc(X,Y,__FUNCTION__)
#define kfree(X)	__kfree(X,__FUNCTION__)

#ifdef page_cache_release
#undef page_cache_release
#endif

#ifdef __free_page
#undef __free_page
#endif

void page_cache_release (struct page *page);
void __free_page (struct page *page);

#endif /* _LDM_EXTRA_H_ */

